///Shapo4ka
#include <bits/stdc++.h>
#define fi first
#define se second
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

typedef vector<int> vii;
typedef vector<ll> vll;

ld bpow(ld a, int n)
{
    ld ans=1;
    while(n)
    {
        if (n & 1)ans*=a;
        a*=a;
        n/=2;
    }
    return ans;
}
//int a[1220][120];
void baga()
{
    cout << "NO\n";
    exit(0);
}
    ll n, m, i, j=1;
    ld r, ans=0;
    pll a[300001];
int main()
{

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    cin.tie(0);
//    cout
    cin >> n >> m >> r;
    for(i=0;i<n;i++)
    {
        cin >> a[i].fi >> a[i].se;
    }
    for(i=0;i<m;i++)cin >> a[i+n].fi, a[i+n].se=1e10;
    sort(a, a+n+m);
    for(i=0;i<n+m;i++)
    {
        if(a[i].se!=1e10)
        {
            ans=ans*bpow(1-r, a[i].fi-j)+a[i].se*r;
            j=a[i].fi;
        }
        else
        {
            ans=ans*bpow(1-r, a[i].fi-j);
            cout << fixed << setprecision(6);
            cout << ans << " ";
            j=a[i].fi;
        }
//        cerr << " " << j << " " << ans << "  " << bpow(1-r, a[i].fi-j) << endl;
    }
    return 0;
}
/*
10 9 3
*/
